洛谷P1090 合并果子

url: https://www.luogu.com.cn/problem/P1090

tag:
哈夫曼(Huffman)树 , 优先队列

思路:因为每次合并果子需要的体力值是两堆果子的重量之和,所以为了让总的体力值最小,可以使用贪心的策略,每次都只合并所有堆中重量最小的两堆。因此可以使用优先队列,每次取出两个头节点,res += 两个节点值的和,再将和的值插入到优先队列,重复这个过程直到队列中只有一个值,最后输出res即可。

代码:

  1. #include <iostream>
  2. #include <queue>
  3. #include <vector>
  4. using namespace std;
  5. int main()
  6. {
  7. priority_queue<int, vector<int>, greater<int> > heap;
  8. int n;
  9. cin >> n;
  10. for (int i = 0; i < n; i ++)
  11. {
  12. int a;
  13. cin >> a;
  14. heap.push(a);
  15. }
  16. long long res = 0;
  17. while(heap.size() > 1)
  18. {
  19. int a = heap.top();
  20. heap.pop();
  21. int b = heap.top();
  22. heap.pop();
  23. res += a + b;
  24. heap.push(a + b);
  25. }
  26. cout << res << endl;
  27. return 0;
  28. }
添加新评论